<?php
namespace FiloBlu\Countdown\Model\Config\Source;

class Countdown implements \Magento\Framework\Option\ArrayInterface
{

    protected $_cdCollectionFactory;
    protected $_escaper;
    
    public function __construct(
        \FiloBlu\Countdown\Model\ResourceModel\Countdown\CollectionFactory $cdCollectionFactory, 
        \Magento\Framework\Escaper $escaper
    ) {
        $this->_cdCollectionFactory = $cdCollectionFactory;
        $this->_escaper = $escaper;
    }
    
    /**
     * @return array
     */
    public function toOptionArray($default = false)
    {
        $collection = $this->_cdCollectionFactory->create();
        $array = [];
        
        if ($default) {
            $array[] = [
                'label' => __('All Countdowns'),
                'value' => 0
            ];
        }
        
        foreach ($collection as $countdown) {
            $array[] = [
                'label' => $this->_escaper->escapeQuote($countdown->getId() . ' - ' . $countdown->getCode(), true),
                'value' => $countdown->getCode()
            ];
        }
        
        return $array;
    }
    
}
